<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Settings;

class SettingsController extends Controller
{
    private $tag_the = 'El';
    private $tag_o = 'o';
    private $r_name = 'admin.settings';
    private $c_name = 'Configuraciones';
    private $c_names = 'Configuraciones';
	private $list_tbl_fsc = [];
	private $o_model = Settings::class;
	
	
	/**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
		$o = $this->o_model::find(1);
		$data['menu'] = 'admin/settings';
        $data['c_name'] = $this->c_name;
        $data['c_names'] = $this->c_names;
        $data['title'] = 'Mi perfil';
        $data['o'] = $o;
		return view($this->r_name.'.edit',$data);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request)
    {
		$data = request()->except(['_token','_method']);
		$validatedData = $request->validate([
			'email' => 'required|string|email|max:255',
		],[
			'email.required' => 'El correo es requerido',
			'email.email' => 'El correo debe ser un correo válido',
			'email.string' => 'El correo debe ser un texto',
			'email.max' => 'El correo no debe exceder más de 255 caracteres',
		]);
		$o = $this->o_model::find(1);
		if($request->has('terms')){
			$file = $request->file('terms');
			$path = $file->store('uploads','public');
			$path = 'storage/'.$path;
			$data['terms'] = asset($path);
		}
		$o->update($data);
		$request->session()->flash('msj_success', 'La configuración ha sido actualizada correctamente.');
		return redirect('admin/settings');
    }
}
