<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Ticket;
use App\Models\Ticketmsj;
use Illuminate\Support\Facades\Auth;

class TicketController extends Controller
{
	private $tag_the = 'El';
    private $tag_o = 'o';
    private $r_name = 'admin/ticket';
    private $v_name = 'admin.ticket';
    private $c_name = 'Ticket';
    private $c_names = 'Tickets';
	private $list_tbl_fsc = ['user' => 'Usuario','date_init' => 'Fecha','title' => 'Asunto','status' => 'Estado'];
	private $o_model = Ticket::class;

	public function __construct(){
    }

	/**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $data['menu'] = $this->r_name;
        $data['tag_o'] = $this->tag_o;
        $data['tag_the'] = $this->tag_the;
        $data['c_name'] = $this->c_name;
        $data['c_names'] = $this->c_names;
        $data['list_tbl_fsc'] = $this->list_tbl_fsc;
        $data['title'] = 'Lista de '.$this->c_names;
		return view($this->v_name.'.index',$data);
    }

	public function o_table()
    {
		$ax = [];
		//$where = ['status' => 'active'];where($where)->
		$o_all = $this->o_model::orderBy('id', 'asc')->get();
		if($o_all->count() > 0){
			foreach($o_all as $key => $row){
				$nk = $key + 1;
				$item = [$nk];
				foreach($this->list_tbl_fsc as $thkey => $value){
					$valor = $row->$thkey;
					if($thkey == 'user'){
						$valor = $row->getUser()->name;
					}
					array_push($item,$valor);
				}
				$btns = '<div class="w-100 text-center"><div class="btn-group" role="group" aria-label="Basic example">';
				$btns .= '<a class="btn btn-info btn-sm" href="'.url($this->r_name.'/'.$row->id).'" title="Ver"><i class="flaticon-settings-1"></i></a>';
				if($row->status != 'Finalizado'){
					$btns .= '<a class="btn btn-warning btn-sm" href="'.url($this->r_name.'/'.$row->id.'/edit').'" title="Editar"><i class="flaticon2-edit"></i></a>';
					$btns .= '<a class="btn btn-danger btn-sm btn-delete-confirm" href="javascript:void(0)" data-href="'.url($this->r_name.'/'.$row->id).'" data-itemtag="' . $this->tag_the . '" data-itemselect="'. $this->tag_o .'" data-nameitem="' . $this->c_name . '" title="Eliminar"><i class="flaticon-delete"></i></a>';
				}
				$btns .= '</div></div>';
				array_push($item,$btns);
				array_push($ax,$item);
			}
		}
		echo json_encode(['data' => $ax],true);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        if(empty($id)){
			return redirect($this->r_name);
		}
		$o = $this->o_model::find($id);
		if(empty($o->id)){
			return redirect($this->r_name);
		}
		$data['menu'] = $this->r_name;
        $data['c_name'] = $this->c_name;
        $data['c_names'] = $this->c_names;
        $data['title'] = 'Detalles de '.$this->c_name;
        $data['o'] = $o;
		$data['o_all'] = Ticketmsj::where(['ticket' => $id])->get();
		return view($this->v_name.'.show',$data);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        if(empty($id)){
			return redirect($this->r_name);
		}
		$o = $this->o_model::find($id);
		if(empty($o->id)){
			return redirect($this->r_name);
		}
		$data['menu'] = $this->r_name;
        $data['c_name'] = $this->c_name;
        $data['c_names'] = $this->c_names;
        $data['title'] = 'Actualizar '.$this->c_name;
        $data['o'] = $o;
		$data['o_all'] = Ticketmsj::where(['ticket' => $id])->get();
		return view($this->v_name.'.edit',$data);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $data = request()->except(['_token','_method']);
		$validatedData = $request->validate([
			'title' => 'required|string',
		],[
			'title.required' => 'El asunto es requerido',
		]);
		if(empty($id)){
			return redirect($this->r_name);
		}
		$o = $this->o_model::find($id);
		if(empty($o->id)){
			return redirect($this->r_name);
		}
		$file = '';
		if ($request->hasFile('file')) {
            $path = $request->file('file')->store('uploads','public');
			$path = 'storage/'.$path;
            $file = asset($path);
        }
		$o_msj = Ticketmsj::create(['user' => Auth::user()->id,'ticket' => $id,'date_init' => date('Y-m-d H:i:s'),'title' => $data['title'],'description' => $data['description'],'file' => $file,'typemsj' => 'Cliente']);
		$request->session()->flash('msj_success', $this->tag_the.' '.$this->c_name.' '.$o->title.' ha sido actualizad'.$this->tag_o.' correctamente.');
		return redirect($this->r_name);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        if(empty($id)){
			return false;
		}
		$o = $this->o_model::findOrFail($id);
		if(empty($o->id)){
			return false;
		}
		$this->o_model::destroy($id);
		$o->update(['status' => 'Finalizado']);
		echo 'ok';
    }
}
