<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\User;
use App\Models\Faqs;
use App\Models\Pages;
use App\Models\Plans;
use App\Models\Ticket;
use App\Models\Banners;
use App\Models\Settings;
use App\Models\Payments;
use App\Models\Ticketmsj;
use App\Models\Planspages;
use App\Models\Tempaccess;
use App\Models\Userspages;
use App\Models\Subaccounts;
use App\Models\Subaccspage;
use App\Models\PersonalAccessToken;
use Illuminate\Support\Str;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Http;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Mail;
use App\Mail\Ntfs;

class HomeController extends Controller
{
    public function index()
    {
		$o_sacc = null;
		if(Auth::user()->role == 'subcuenta'){
			$o_sacc = Subaccounts::where(['id' => Auth::user()->sacc])->first();
		}
		$data['menu'] = 'home';
        $data['title'] = 'Página de inicio';
        $o_lmb = $this->get_last_membership(Auth::user()->id);
        $data['o_lmb'] = $o_lmb;
        $data['b_all'] = Banners::all();
		$o_all = Pages::all();
		$list_i_all = [0];
		if($o_lmb != FALSE){
			$i_all = Planspages::where(['plans_id' => $o_lmb->id])->get();
			if($i_all->count() > 0){
				foreach($i_all as $key => $row){
					if(Auth::user()->role == 'subcuenta'){
						$o_saccpage = Subaccspage::where(['subaccounts_id' => $o_sacc->id,'pages_id' => $row->pages_id])->first();
						if(!empty($o_saccpage->id)){
							$list_i_all[] = $row->pages_id;
						}
					} else {
						$list_i_all[] = $row->pages_id;
					}
				}
			}
			//$o_all = Pages::whereIn('id',$list_i_all)->orderBy('id', 'asc')->get();
		}
		//echo var_dump($list_i_all);exit();
		$data['o_all'] = $o_all;
		$data['o_config'] = $o_config = Settings::find(1);
		$data['list_i_all'] = $list_i_all;
		
		//test
		/*$issuedTokens = PersonalAccessToken::where('tokenable_type', User::class)->where('tokenable_id', Auth::user()->id)->get();
		if ($issuedTokens->count() > 1) {
			$returnMessage = 'You have to remove on of the following devices:<br>';
			echo $returnMessage;
			$deviceNames = $issuedTokens->pluck('name')->toArray();
			echo var_dump($deviceNames);
			exit();
		}*/
        return view('home', $data);
    }
    public function faqs()
    {
		$data['menu'] = 'faqs';
        $data['title'] = 'Preguntas frecuentes';
		$data['o_all'] = Faqs::all();
		$data['o_config'] = $o_config = Settings::find(1);
        return view('faqs', $data);
    }
    public function payments()
    {
		$data['menu'] = 'payments';
        $data['title'] = 'Mis pagos';
		$data['o_all'] = Payments::with(['user','plan'])->where(['user' => Auth::user()->id])->orderBy('id', 'desc')->get();
        $data['o_config'] = $o_config = Settings::find(1);
		return view('payments', $data);
    }
    public function planes()
    {
		//$id = 1;
		$id = Auth::user()->id;
		$data['menu'] = 'planes';
        $data['title'] = 'Membresías';
		$data['o_all'] = Plans::where(['is_public' => 'si'])->orderBy('id', 'desc')->get();
		$data['us_id'] = $id;
		$data['o_config'] = $o_config = Settings::find(1);
        return view('planes', $data);
    }
    public function support()
    {
		$data['menu'] = 'support';
        $data['title'] = 'Soporte';
		$data['o_all'] = Ticket::with(['user','msjs'])->where(['user' => Auth::user()->id])->get();
		$data['o_config'] = $o_config = Settings::find(1);
		return view('support', $data);
    }
    public function supportnew()
    {
		$data['menu'] = 'support';
        $data['title'] = 'Soporte';
		$data['o_config'] = $o_config = Settings::find(1);
		return view('supportnew', $data);
    }
    public function addticket(Request $request)
    {
		$data = request()->except(['_token','_method']);
		$validator = Validator::make($data, [
            'title' => 'required',
            'description' => 'required',
        ],[
			'name.required' => 'El asunto es requerido',
			'description.required' => 'La descripción es requerida',
		]);
		if ($validator->fails()) {
			return redirect('support')->withErrors($validator)->withInput();
		}
		$user = Auth::user()->id;
		$date_init = date('Y-m-d H:i:s');
		$data['date_init'] = $date_init;
		$data['user'] = $user;
		$o = Ticket::create($data);
		$file = '';
		if ($request->hasFile('file')) {
            $path = $request->file('file')->store('uploads','public');
			$path = 'storage/'.$path;
            $file = asset($path);
        }
		$o_msj = Ticketmsj::create(['user' => $user,'ticket' => $o->id,'date_init' => $date_init,'title' => $data['title'],'description' => $data['description'],'file' => $file,'typemsj' => 'Cliente']);
		request()->session()->flash('msj_success', 'El ticket ha sido creado correctamente');
		//Notificar por correo
		Mail::to(Auth::user()->email)->send(new Ntfs('Nuevo ticket','Gracias por comunicarse con el equipo de soporte, en breve te contactaremos',Auth::user()->name,Auth::user()->email));
		$o_config = Settings::find(1);
		if(!empty($o_config->email)){
			Mail::to($o_config->email)->send(new Ntfs('Nuevo ticket','El usuario '.Auth::user()->name.' ha solicitado un nuevo ticket de soporte: '.$data['title'],'Administrador',$o_config->email));
		}
		return redirect('support');
    }
    public function supportshow($id = '')
    {
		$o = Ticket::with(['user','msjs'])->where(['id' => $id,'user' => Auth::user()->id])->first();
		if(empty($o->id)){
			return redirect('support');
		}
		$data['menu'] = 'support';
        $data['title'] = 'Soporte';
        $data['o'] = $o;
		$data['o_all'] = Ticketmsj::where(['ticket' => $id])->get();
		$data['o_config'] = $o_config = Settings::find(1);
		return view('supportshow', $data);
    }
	public function supportup(Request $request,$id)
    {
		$o = Ticket::where(['id' => $id,'user' => Auth::user()->id])->first();
		if(empty($o->id)){
			return redirect('support');
		}
		$data = request()->except(['_token','_method']);
		$validator = Validator::make($data, [
            'title' => 'required',
            'description' => 'required',
        ],[
			'name.required' => 'El asunto es requerido',
			'description.required' => 'La descripción es requerida',
		]);
		if ($validator->fails()) {
			return redirect('support/'.$id)->withErrors($validator)->withInput();
		}
		
		$file = '';
		if ($request->hasFile('file')) {
            $path = $request->file('file')->store('uploads','public');
			$path = 'storage/'.$path;
            $file = asset($path);
        }
		$o_msj = Ticketmsj::create(['user' => Auth::user()->id,'ticket' => $id,'date_init' => date('Y-m-d H:i:s'),'title' => $data['title'],'description' => $data['description'],'file' => $file,'typemsj' => 'Cliente']);
		request()->session()->flash('msj_success', 'El ticket ha sido respondido correctamente');
		return redirect('support/'.$id);
    }
	
    public function menu()
    {
        $data['title'] = 'Página de inicio';
		$data['o_config'] = $o_config = Settings::find(1);
        return view('menu', $data);
    }
	
    public function bell()
    {
        $data['title'] = 'Página de inicio';
		$data['o_config'] = $o_config = Settings::find(1);
        return view('bell', $data);
    }
	
    public function highlights()
    {
        $data['title'] = 'Página de inicio';
		$data['o_config'] = $o_config = Settings::find(1);
        return view('highlights', $data);
    }
	
    public function pay_response()
    {
        $data['title'] = 'Respuesta de pago';
		$data['o_config'] = $o_config = Settings::find(1);
        return view('response', $data);
    }
	
    public function pay_success()
    {
        request()->session()->flash('msj_success', 'El pago ha sido completado correctamente');
		return redirect('payments');
    }
	
    public function ajax_data()
    {
        //$params = ['referencia' => $_POST['referencia'],'recibo' => $_POST['recibo'],'ref_payco' => $_POST['ref_payco'],'extra1' => $_POST['extra1'],'extra2' => $_POST['extra2'],'extra3' => $_POST['extra3'],'monto' => $_POST['monto'],'moneda' => $_POST['moneda'],'respuesta' => $_POST['respuesta'],'franchise' => $_POST['franchise']];
		$x_id_invoice = $_POST['referencia'];
		$user_id = $_POST['extra1'];
		$plan_id = $_POST['extra2'];
		$o_pay = Payments::where(['user' => $user_id,'plan' => $plan_id,'invoice' => $x_id_invoice])->first();
		if(empty($o_pay->id)){
			$o_plan = Plans::where(['id' => $plan_id])->first();
			$expiration = $this->plusMonth($o_plan->month);
			$amount = $_POST['monto'];
			$x_currency_code = $_POST['moneda'];
			$x_response = $_POST['respuesta'];
			$franchise = $_POST['franchise'];
			$x_ref_payco = $_POST['ref_payco'];
			$o = Payments::create(['user' => $user_id,'plan' => $plan_id,'invoice' => $x_id_invoice,'amount' => $amount,'currency' => $x_currency_code,'response' => $x_response,'franchise' => $franchise,'date_init' => date('Y-m-d'),'expiration' => $expiration,'description' => $x_ref_payco]);
			return TRUE;
		}
    }
	
    public function freeplan($id)
    {
        //$params = ['referencia' => $_POST['referencia'],'recibo' => $_POST['recibo'],'ref_payco' => $_POST['ref_payco'],'extra1' => $_POST['extra1'],'extra2' => $_POST['extra2'],'extra3' => $_POST['extra3'],'monto' => $_POST['monto'],'moneda' => $_POST['moneda'],'respuesta' => $_POST['respuesta'],'franchise' => $_POST['franchise']];
		$x_id_invoice = uniqid();
		$user_id = Auth::user()->id;
		$plan_id = $id;
		$o_pay = Payments::where(['user' => $user_id,'plan' => $plan_id])->first();
		if(empty($o_pay->id)){
			$o_plan = Plans::where(['id' => $plan_id])->first();
			$expiration = $this->expiration($o_plan->month);
			$amount = 0;
			$x_currency_code = 'COP';
			$x_response = 'Aceptado';
			$franchise = 'Free';
			$x_ref_payco = uniqid();
			$o = Payments::create(['user' => $user_id,'plan' => $plan_id,'invoice' => $x_id_invoice,'amount' => $amount,'currency' => $x_currency_code,'response' => $x_response,'franchise' => $franchise,'date_init' => date('Y-m-d'),'expiration' => $expiration,'description' => $x_ref_payco]);
			request()->session()->flash('msj_success', 'La suscripción ha sido completada correctamente');
			echo 'ok';
		} else {
			echo 'Lo sentimos, ya ha ha usado la suscripción gratuita, solo puede usarse una vez.';
		}
    }
	
	private function expiration($d = 30) {
		$fecha = date('Y-m-j');
		$nuevafecha = strtotime ( '+'.$d.' day' , strtotime ( $fecha ) ) ;
		$nuevafecha = date ( 'Y-m-d' , $nuevafecha );
		return $nuevafecha;
    }
	
	private function plusMonth($m = 1) {
		$d = date('Y-m-d');
		$nd = strtotime ('+'.$m.' month', strtotime($d)) ;
		return date ('Y-m-d', $nd);
    }
	
	private function last_membership($id)
    {
		$o = Payments::where(['user' => $id])->orderBy('id', 'desc')->first();
		if(!empty($o->id)){
			//verificar que la fecha de expiration no este vencida
			$expiration = strtotime($o->expiration);
			$aux = date('Y-m-d');
			$currentDate = strtotime($aux);
			if($currentDate < $expiration){
				return TRUE;
			}
		}
		return FALSE;
    }
	
	private function get_last_membership($id)
    {
		$o_us = User::where(['id' => $id])->first();
		if($o_us->role == 'subcuenta'){
			$o_sacc = Subaccounts::where(['id' => $o_us->sacc])->first();
			if(!empty($o_sacc->id)){
				$id = $o_sacc->user;
			}
		}
		$o = Payments::where(['user' => $id])->orderBy('id', 'desc')->first();
		if(!empty($o->id)){
			//verificar que la fecha de expiration no este vencida
			$expiration = strtotime($o->expiration);
			$aux = date('Y-m-d');
			$currentDate = strtotime($aux);
			if($currentDate < $expiration){
				return Plans::where(['id' => $o->plan])->first();
			}
		}
		return FALSE;
    }
	
	private function sendpost($url,$fields)
    {
		$fields_string = http_build_query($fields);
		$ch = curl_init();
		curl_setopt($ch,CURLOPT_URL, $url);
		curl_setopt($ch,CURLOPT_POST, true);
		curl_setopt($ch,CURLOPT_POSTFIELDS, $fields_string);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER, true); 
		$result = curl_exec($ch);
		return $result;
    }
	
	//Load access
	public function tempaccess(Request $request)
    {
		$data = request()->except(['_token','_method']);
		$res = $this->log_sh_access($data['page']);
		if($res['ok']){
			$code = $res['msj'];
			$url = $this->load_url($data['page'],$code);
			echo $url;
		} else {
			echo $res['msj'];
		}
    }
	
	//Load access
	public function tempaccesslink(Request $request)
    {
		$data = request()->except(['_token','_method']);
		$linkp = $data['linkp'];
		$res = $this->log_sh_access($data['page']);
		if($res['ok']){
			$code = $res['msj'];
			$url = $this->load_url($data['page'],$code,$linkp);
			echo $url;
		} else {
			echo $res['msj'];
		}
    }
	
	public function extaccess($id)
    {
		
		$home_prestigio = url('/');
		$o_lmb = $this->get_last_membership(Auth::user()->id);
		if((empty($o_lmb) OR $o_lmb == FALSE) AND $id == 4){
			//btn_noplan_fsc
			request()->session()->flash('msj_error', 'Debes adquirir un plan para acceder a la página solicitada.');
			return redirect('/');exit();
		} else if(in_array($id,[8])){
			//btn_next_dev
			request()->session()->flash('msj_error', 'Esta página no se encuentra disponible hasta próximo aviso.');
			return redirect('/');exit();
		}
		/*$list_i_all = [0];
		if($o_lmb != FALSE){
			$i_all = Planspages::where(['plans_id' => $o_lmb->id])->get();
			if($i_all->count() > 0){
				foreach($i_all as $key => $row){
					if(Auth::user()->role == 'subcuenta'){
						$o_saccpage = Subaccspage::where(['subaccounts_id' => $o_sacc->id,'pages_id' => $row->pages_id])->first();
						if(!empty($o_saccpage->id)){
							$list_i_all[] = $row->pages_id;
						}
					} else {
						$list_i_all[] = $row->pages_id;
					}
				}
			}
		}
		if(!in_array($id,$list_i_all)){
			//btn_noplanlimit_fsc
			request()->session()->flash('msj_error', 'La membresía no tiene incluido el acceso solicitado.');
			return redirect('/');exit();
		}*/
		$res = $this->log_sh_access($id);
		if($res['ok']){
			$pages = [1,2,3,4,5,7,8,9,10];
			$code = $res['msj'];
			//Paso 4, retornar la URL del nuevo acceso
			$url = $this->load_url($id,$code);
			header('Location: '.$url);exit();
		}
		//error
		request()->session()->flash('msj_error', $res['msj']);
		return redirect('/');exit();
    }
	
	private function log_sh_access($id)
    {
        $path = 'https://prestigioapp.com/api/api/index';
		$o_page = Pages::where(['id' => $id])->first();
		if(empty($o_page->id)){
			return ['ok' => FALSE,'msj' => 'La pagina solicitada no existe'];
		}
		$code = Str::random(8);
		$o_user = Auth::user();
		$id_user = Auth::user()->id;
		if(Auth::user()->role == 'subcuenta'){
			$o_sacc = Subaccounts::where(['id' => Auth::user()->sacc])->first();
			if(!empty($o_sacc->id)){
				$id_user = $o_sacc->user;
				$o_user = User::where(['id' => $id_user])->first();
			}
		}
		
		if($id != 18){
			//Paso 1, verificar que tenga suscripcion activa, sino tiene retornar ERROR.
			/*if(!$this->last_membership($id_user)){
				return ['ok' => FALSE,'msj' => 'No tiene una suscripción activa'];
			}*/
			//Paso 2, verificar que el usuario $id_user este registrado para la pagina $id, sino esta registrado registrarlo.
			$o_up = Userspages::where(['user' => $id_user,'page' => $id])->first();
			if(empty($o_up->id) AND $id != 6){
				//Registrar al usuario en la pagina y obtener el ID de ese registro
				$params = [
					'acc' => 'register',
					'page' => $id,
					'name' => $o_user->name,
					'email' => $o_user->email,
					'api_token' => Str::random(40)
				];
				
				if($id == 4){
					$path = 'https://movies.prestigioapp.com/fsc/newaccfscc';
					$params = [
						'name' => $o_user->name,
						'email' => $o_user->email,
						'code' => $code
					];
				} else if($id == 9){
					$path = 'https://cupido.prestigioapp.com/login?regfsc=reg';
					$params = [
						'name' => $o_user->name,
						'email' => $o_user->email,
						'code' => $code
					];
				}
				$user_local = $this->sendpost($path, $params);
				$user_local = str_replace('"','',$user_local);
				if($user_local == false OR $user_local == 'false' OR empty($user_local)){
					return ['ok' => FALSE,'msj' => 'No se ha podido completar el registro'];
				}
				$o_up = Userspages::create(['user' => $id_user,'page' => $id,'user_local' => $user_local]);
			}
			//Paso 3, generar un enlace de acceso para la pagina $data['page'] solicitada
			if($id != 6){
				$params = [
					'acc' => 'access',
					'page' => $id,
					'user' => $o_up->user_local,
					'code' => $code
				];
				if($id == 4){
					$path = 'https://movies.prestigioapp.com/fsc/tempacc';
					$params = [
						'user' => $o_up->user_local,
						'code' => $code
					];
				} else if($id == 9) {
					$path = 'https://cupido.prestigioapp.com/login?regfsc=log';
					$params = [
						'user' => $o_user->email,
						'code' => $code
					];
				}
				$response = $this->sendpost($path, $params);
				/*if($id == 4){
					$o_new = Tempaccess::create(['user' => $o_up->user_local,'code' => $code]);
				} else {
					$response = $this->sendpost($path, [
						'acc' => 'access',
						'page' => $id,
						'user' => $o_up->user_local,
						'code' => $code
					]);
				}*/
			}
		} else {
			return ['ok' => FALSE,'msj' => 'Esta página no se encuentra disponible hasta próximo aviso.'];
		}
		return ['ok' => TRUE,'msj' => $code];
    }
	
	//1 => Son
	//2 => Gambler(Social)
	//3 => momentos
	//4 => coliseo
	//5 => outlet(Social)
	//6 => crucero
	//7 => fama
	//8 => visaje9
	private function load_url($page,$code,$linkp = ''){
		//Paso 4, retornar la URL del nuevo acceso
		$o_page = Pages::where(['id' => $page])->first();
		
		$id_user = Auth::user()->id;
		if(Auth::user()->role == 'subcuenta'){
			$o_sacc = Subaccounts::where(['id' => Auth::user()->sacc])->first();
			if(!empty($o_sacc->id)){
				$id_user = $o_sacc->user;
			}
		}
		$tag_url = 'url';
		if($this->last_membership($id_user)){
			$o_mb = Payments::where(['user' => $id_user])->orderBy('id', 'desc')->first();
			$o_plan = Plans::where(['id' => $o_mb->plan])->first();
			$tag_url = (!empty($o_plan->id) AND $o_plan->is_premium=='si')?'premium':'url';
		}
		$page_url = $o_page->$tag_url;
		$url = $page_url.'tempaccess/'.$code;
		$banner = '';
		if(!empty($linkp)){
			$banner = $page == 1?'/'.urlencode($linkp):'&lk='.urlencode($linkp);
		}
		if($page == 1){
			$url = $page_url.'tempaccess/'.$code;
		} else if($page == 2){
			$url = $page_url.'register?code='.$code.'&p=1'.$banner;
		} else if($page == 3){
			$url = $page_url.'tempaccess?code='.$code.'&p=1'.$banner;
		} else if($page == 4){
			$url = $page_url.'fsc/tempacces/'.$code;
		} else if($page == 5){
			$url = $page_url.'register?code='.$code.'&p=2'.$banner;
		} else if($page == 6){
			$url = $page_url;
		} else if($page == 7){
			$url = $page_url.'register?code='.$code.'&p=0'.$banner;
		} else if($page == 8){
			//$url = url('/');
			$url = $page_url.'register?code='.$code.'&p=4'.$banner;
		} else if($page == 9){
			//$url = $page_url.'tempaccess?code='.$code.'&p=2'.$banner;
			$url = $page_url.'login?regfsc=cd&code='.$code;
		} else if($page == 10){
			$url = $page_url.'register?code='.$code.'&p=3'.$banner;
			//$url = $page_url.'tempaccess?code='.$code.'&p=3'.$banner;
		}
		return $url;
	}
	
	public function lggettemp()
    {
		$o = User::where(['status' => 'active'])->first();
		$x = Auth::loginUsingId($o->id);
		//echo var_dump($x);exit();
		return redirect('support');
    }
}
