<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Pages;

class PagesController extends Controller
{
    /**
     *
     *  @OA\Get(
     *  path="/api/pages",
     *  summary="Lista de paginas",
     *  operationId="getAllPages",
     *  tags={"Pages"},
     *  security={{ "apiAuth": {} }},
     *  @OA\Response(response=200, description="Obtiene la lista de paginas", @OA\JsonContent())
     * )
     **/
    public function index()
    {
        return $this->sendResponse(Pages::all(), 'Lista de paginas');
    }
}
