<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\User;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Auth;

class ProfileController extends Controller
{
    private $menu = 'profile';
    private $title = 'Perfil';
    private $o_model = User::class;
	
    public function index()
    {
        $data['menu'] = $this->menu;
        $data['c_name'] = $this->title;
        $data['title'] = 'Lista de '.$this->title.'es';
        $data['o'] = $this->o_model::where(['id' => Auth::user()->id])->first();
        return view($this->menu, $data);
    }

    public function update(Request $request)
    {
        $data = request()->except(['_token','_method']);
		$validator = Validator::make($data, [
            'name' => 'required|string|max:255',
			'email' => 'required|string|email|max:255|unique:users,email,'.Auth::user()->id,
        ],[
			'name.required' => 'El nombre es requerido',
			'name.string' => 'El nombre debe ser un texto',
            'name.max' => 'El nombre no debe exceder más de 255 caracteres',
			'email.required' => 'El correo es requerido',
            'email.email' => 'El correo debe ser un correo válido',
            'email.string' => 'El correo debe ser un texto',
            'email.max' => 'El correo no debe exceder más de 255 caracteres',
            'email.unique' => 'El correo ya existe en la base de datos',
		]);
		if ($validator->fails()) {
			return redirect($this->menu)->withErrors($validator)->withInput();
		}
        $o = $this->o_model::where(['id' => Auth::user()->id])->first();
		$data['passwd'] = $data['password'];
		$data['password'] = bcrypt($data['password']);
		if ($request->hasFile('photo')) {
            $path = $request->file('photo')->store('uploads','public');
			$path = 'storage/'.$path;
            $data['photo'] = asset($path);
        }
        $o->update($data);
		$request->session()->flash('msj_success', 'El perfil ha sido actualizado correctamente');
		return redirect($this->menu);
    }
}
