<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\User;

class UsersController extends Controller
{
    private $menu = 'admin/users';
    private $title = 'Usuario';
    private $o_model = User::class;
	
    public function index()
    {
        $data['menu'] = $this->menu;
		$data['c_name'] = $this->title;
        $data['title'] = 'Lista de '.$this->title.'s';
        $data['o_all'] = $this->o_model::all();
        return view($this->menu.'.index', $data);
    }

    public function create()
    {
        $data['menu'] = $this->menu;
		$data['c_name'] = $this->title;
        $data['title'] = 'Nuevo '.$this->title;
        return view($this->menu.'.create', $data);
    }
	
    public function store(Request $request)
    {
        $data = $request->except(['_token','_method']);
		$data['password'] = bcrypt($data['password']);
		if ($request->hasFile('photo')) {
            $path = $request->file('photo')->store('uploads','public');
			$path = 'storage/'.$path;
            $data['photo'] = asset($path);
        }
        $o = $this->o_model::create($data);
        $request->session()->flash('msj_success', 'El '.strtolower($this->title).' ha sido creado correctamente');
		return redirect($this->menu);
    }

    
    public function show($id)
    {
		$data['menu'] = $this->menu;
		$data['c_name'] = $this->title;
        $data['title'] = 'Detalles del '.$this->title;
        $data['o'] = $this->o_model::where(['id' => $id])->first();
        return view($this->menu.'.show', $data);
    }

    
    public function update(Request $request, $id)
    {
        $data = $request->except(['_token','_method']);
		$data['password'] = bcrypt($data['password']);
		if ($request->hasFile('photo')) {
            $path = $request->file('photo')->store('uploads','public');
			$path = 'storage/'.$path;
            $data['photo'] = asset($path);
        }
        $o = $this->o_model::where(['id' => $id])->first();
        $o->update($data);
		$request->session()->flash('msj_success', 'El '.strtolower($this->title).' ha sido actualizado correctamente');
		return redirect($this->menu);
    }

    
    public function destroy($id)
    {
        $o = $this->o_model::where(['id' => $id])->first();
        $this->o_model::destroy($id);
		$request->session()->flash('msj_success', 'El '.strtolower($this->title).' ha sido eliminado correctamente');
		echo 'ok';
    }
}
