<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Payments extends Model
{
    use HasFactory;
	
	protected $table = 'payments';

    protected $guarded = ['id'];
	
	public function getPlan()
    {
        $o = Plans::where(['id' => $this->plan])->first();
		return !empty($o->id)?$o->name:'Plan eliminado';
    }
	
    public function plan()
    {
        return $this->belongsTo(Plans::class,'plan');
    }
	
    public function getUser()
    {
        return User::findOrFail($this->user)->name;
    }
	
    public function user()
    {
        return $this->belongsTo(User::class,'user');
    }
}
