<?php
// app/Services/SupabaseService.php

namespace App\Services;

use GuzzleHttp\Client;

class SupabaseService
{
    protected $client;
    protected $supabaseUrl;
    protected $supabaseKey;

    public function __construct()
    {
        $this->supabaseUrl = env('SUPABASE_URL');
        $this->supabaseKey = env('SUPABASE_KEY');
        $this->client = new Client([
            'base_uri' => $this->supabaseUrl,
            'headers' => [
                'apikey' => $this->supabaseKey,
                'Content-Type' => 'application/json'
            ]
        ]);
    }

    public function login($email, $password)
    {
        $response = $this->client->post('/auth/v1/token?grant_type=password', [
            'json' => [
                'email' => $email,
                'password' => $password
            ]
        ]);

        return json_decode($response->getBody(), true);
    }

    public function getUser($accessToken)
    {
        $response = $this->client->get('/auth/v1/user', [
            'headers' => [
                'Authorization' => 'Bearer ' . $accessToken,
            ]
        ]);

        return json_decode($response->getBody(), true);
    }
}
