<?php

use Illuminate\Support\Facades\Route;
use hisorange\BrowserDetect\Parser as Browser;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/logouut', function () {
// Delete the cookie named 'prestigio_session' on the domain '.prestigioapp.com'
setcookie('prestigio_session', '', time() - 3600, '/', '.prestigioapp.com');

// Delete the cookie named 'prestigio_session' on the domain 'prestigioapp.com'
setcookie('prestigio_session', '', time() - 3600, '/', 'prestigioapp.com');

echo "prestigio_session cookie deleted.";
});

Route::get('/clear', function () {
    //1- borrar la carpeta storage en el path public/storage
	//2- correr la url /clear
	Artisan::call('cache:clear');
	Artisan::call('view:clear');
    Artisan::call('route:clear');
    Artisan::call('storage:link', [] );
});
Route::get('extaccessx/{id}', [App\Http\Controllers\HomeController::class, 'extaccess']);
Route::get('extaccess/{id}', function ($id) {
   $dv = Browser::deviceType();
	if($dv == 'Desktop'){
		return redirect('https://web.prestigioapp.com/extaccess/'.$id);
	} else {
		return redirect('extaccessx/'.$id);
	}
});

/*Route::get('extaccess/{id}', function ($id) {
    //Route::get('extaccess/{id}', [App\Http\Controllers\HomeController::class, 'extaccess']);
	return redirect('https://web.prestigioapp.com/extaccess/'.$id);
});*/

Route::get('login', [App\Http\Controllers\AuthController::class, 'index']);
Route::post('login', [App\Http\Controllers\AuthController::class, 'store']);
Route::post('user/verify_token', [App\Http\Controllers\AuthController::class, 'isTokenExpired']);
Route::post('siteaccess', [App\Http\Controllers\AuthController::class, 'siteaccess'])->name('siteaccess');
Route::post('api/siteaccess', [App\Http\Controllers\AuthController::class, 'siteaccess']);
Route::get('admin/login', [App\Http\Controllers\Admin\AuthController::class, 'index']);
Route::post('admin/login', [App\Http\Controllers\Admin\AuthController::class, 'store']);

Route::get('logout', [App\Http\Controllers\AuthController::class, 'logout']);
Route::post('logout', [App\Http\Controllers\AuthController::class, 'logout']);
Route::get('admin/logout', [App\Http\Controllers\Admin\AuthController::class, 'logout']);
Route::post('admin/logout', [App\Http\Controllers\Admin\AuthController::class, 'logout']);

Route::middleware(['guest'])->group(function () {
	Route::group([
        'prefix' => 'register'
    ], function () {
        Route::get('/', [App\Http\Controllers\RegisterController::class, 'index']);
        Route::get('/vdemail', [App\Http\Controllers\RegisterController::class, 'vdemail']);
        Route::get('/verificar', [App\Http\Controllers\RegisterController::class, 'verificar']);
        Route::post('/', [App\Http\Controllers\RegisterController::class, 'store']);
        Route::post('/vdemail', [App\Http\Controllers\RegisterController::class, 'validaccount']);
        Route::post('/verificar', [App\Http\Controllers\RegisterController::class, 'validcode']);
    });
	//Recovery
    Route::group([
        'prefix' => 'recovery'
    ], function () {
        Route::get('/', [App\Http\Controllers\RecoveryController::class, 'index'])->name('recovery.index');
		Route::post('/', [App\Http\Controllers\RecoveryController::class, 'store'])->name('recovery.store');
		
		Route::get('/verify', [App\Http\Controllers\RecoveryController::class, 'verify'])->name('recovery.verify');
        Route::post('/verify', [App\Http\Controllers\RecoveryController::class, 'checkkey'])->name('recovery.checkkey');
		
		Route::get('/new', [App\Http\Controllers\RecoveryController::class, 'newpassword'])->name('recovery.newpassword');
		Route::post('/new', [App\Http\Controllers\RecoveryController::class, 'update'])->name('recovery.update');
    });
});
Route::get('lggettemp', [App\Http\Controllers\HomeController::class, 'lggettemp']);
Route::middleware(['authadmin'])->group(function () {
	//Admin
	Route::group([
        'prefix' => 'admin'
    ], function () {
        Route::get('/', [App\Http\Controllers\Admin\HomeController::class, 'index']);
		
		//Settings
		Route::get('settings', [App\Http\Controllers\Admin\SettingsController::class, 'index']);
		Route::patch('settings', [App\Http\Controllers\Admin\SettingsController::class, 'update']);
		
		//Profile
		Route::get('profile', [App\Http\Controllers\Admin\ProfileController::class, 'index']);
		Route::patch('profile', [App\Http\Controllers\Admin\ProfileController::class, 'update']);
		
		//Faqs
		Route::get('faqs/o_table', [App\Http\Controllers\Admin\FaqsController::class, 'o_table']);
		Route::resource('faqs', App\Http\Controllers\Admin\FaqsController::class);
		
		//Banners
		Route::get('banners/o_table', [App\Http\Controllers\Admin\BannersController::class, 'o_table']);
		Route::resource('banners', App\Http\Controllers\Admin\BannersController::class);
		
		//Planes
		Route::get('plans/o_table', [App\Http\Controllers\Admin\PlansController::class, 'o_table']);
		Route::post('plansp', [App\Http\Controllers\Admin\PlansController::class, 'plansp']);
		Route::resource('plans', App\Http\Controllers\Admin\PlansController::class);
		
		//Planes
		Route::get('soporte/o_table', [App\Http\Controllers\Admin\SoporteController::class, 'o_table']);
		Route::resource('soporte', App\Http\Controllers\Admin\SoporteController::class);
		
		//Usuarios
		Route::get('users/o_table', [App\Http\Controllers\Admin\UsersController::class, 'o_table']);
		Route::get('users/plan/{id}', [App\Http\Controllers\Admin\UsersController::class, 'plan']);
		Route::post('users/plan/{id}', [App\Http\Controllers\Admin\UsersController::class, 'updplan']);
		Route::resource('users', App\Http\Controllers\Admin\UsersController::class);
		
		//Payments
		Route::get('payments', [App\Http\Controllers\Admin\PaymentsController::class, 'index']);
		Route::get('payments/o_table', [App\Http\Controllers\Admin\PaymentsController::class, 'o_table']);
		
    });
});
//
Route::middleware(['auth:sanctum'])->group(function () {
	//Dashboard
	Route::get('/', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
	Route::get('home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
	Route::get('faqs', [App\Http\Controllers\HomeController::class, 'faqs'])->name('faqs');
	Route::get('payments', [App\Http\Controllers\HomeController::class, 'payments'])->name('payments');
	Route::get('planes', [App\Http\Controllers\HomeController::class, 'planes'])->name('planes');
	Route::get('support', [App\Http\Controllers\HomeController::class, 'support'])->name('support');
	Route::post('support', [App\Http\Controllers\HomeController::class, 'addticket'])->name('addticket');
	Route::get('support/create', [App\Http\Controllers\HomeController::class, 'supportnew'])->name('supportnew');
	Route::get('support/{id}', [App\Http\Controllers\HomeController::class, 'supportshow'])->name('supportshow');
	Route::post('support/{id}', [App\Http\Controllers\HomeController::class, 'supportup'])->name('supportup');
	Route::get('menu', [App\Http\Controllers\HomeController::class, 'menu'])->name('menu');
	Route::get('bell', [App\Http\Controllers\HomeController::class, 'bell'])->name('bell');
	Route::get('highlights', [App\Http\Controllers\HomeController::class, 'highlights'])->name('highlights');
	//Payments
	Route::post('freeplan/{id}', [App\Http\Controllers\HomeController::class, 'freeplan'])->name('freeplan');
	Route::get('pay/response', [App\Http\Controllers\HomeController::class, 'pay_response'])->name('pay_response');
	Route::get('pay/success', [App\Http\Controllers\HomeController::class, 'pay_success'])->name('pay_success');
	Route::get('ajax_data', [App\Http\Controllers\HomeController::class, 'ajax_data'])->name('ajax_data');
	Route::post('ajax_data', [App\Http\Controllers\HomeController::class, 'ajax_data'])->name('ajax_data');
	Route::post('tempaccess', [App\Http\Controllers\HomeController::class, 'tempaccess'])->name('tempaccess');
	Route::post('tempaccesslink', [App\Http\Controllers\HomeController::class, 'tempaccesslink'])->name('tempaccesslink');
	//Route::get('extaccess/{id}', [App\Http\Controllers\HomeController::class, 'extaccess']);
	//Profile
	Route::get('profile', [App\Http\Controllers\ProfileController::class, 'index']);
	Route::post('profile', [App\Http\Controllers\ProfileController::class, 'update']);
	//Subaccounts
	Route::get('subaccounts', [App\Http\Controllers\SubaccountsController::class, 'index']);
	Route::get('subaccounts/create', [App\Http\Controllers\SubaccountsController::class, 'create']);
	Route::post('subaccounts', [App\Http\Controllers\SubaccountsController::class, 'store']);
	Route::get('subaccounts/{id}', [App\Http\Controllers\SubaccountsController::class, 'edit']);
	Route::post('subaccounts/{id}', [App\Http\Controllers\SubaccountsController::class, 'update']);
	Route::post('saccpages', [App\Http\Controllers\SubaccountsController::class, 'saccpages']);
	
});
